controllers.controller('AppCtrl', function (
		$scope,
		$ionicModal,
		$timeout,
		$rootScope,
		$location,
		LocalStorageService,
		AppServiceManager,
		$ionicPopup,
		$state,
		PushNotificationHandler,
		AnalyticService,
		AdsService
		) {

	$scope.state = $state;

	// Form data for the login modal
	$scope.loginData = {};

	// Create the login modal that we will use later
	$ionicModal.fromTemplateUrl('templates/login.html', {
		scope: $scope
	}).then(function (modal) {
		$scope.modal = modal;
	});

	// Triggered in the login modal to close it
	$scope.closeLogin = function () {
		$scope.modal.hide();
	};

	// Open the login modal
	$scope.login = function () {
		$scope.modal.show();
	};

	// Perform the login action when the user submits the login form
	$scope.doLogin = function () {
		console.log('Doing login', $scope.loginData);

		// Simulate a login delay. Remove this and replace with your login
		// code if using a login system
		$timeout(function () {
			$scope.closeLogin();
		}, 1000);
	};

	//Subheader
	$rootScope.hideSubHeader = false;
	$rootScope.slideHeaderPrevious = 0;

	$rootScope.location = $location;

	//MagazineFooter
	$rootScope.slideFooterPrevious = 0;
	$rootScope.hideFooter = false;

	//FormsRootScope
	$rootScope.forms = {};

	//Device Registering
	document.addEventListener("deviceready", function(){

		AnalyticService.startTrackerWithId(analytics_ua);

		if(new_version_checked){

			getAppVersion(function(version) {

				AppServiceManager.getData(
					'MotofanApiService',
					'checkVersion',
					[version],
					false
				).then(function(data){
					if(typeof data !== 'undefined'){

						var app_version = parseInt(data.version.replace(/[.@]/g, ""));
						var device_version = parseInt(version.replace(/[.@]/g, ""));

						console.log("Device version: "+device_version+" App version: "+app_version);

						if(device_version < app_version){
							console.log("New app version found");
							alertNewVersion($scope, $ionicPopup, data.url_upgrade);
						}
						new_version_checked = false;
					}
				});
			});
		}

		if(!LocalStorageService.get('device_id')){
			AppServiceManager.getData(
				'MotofanApiService',
				'saveDevice',
				[device.uuid],
				false
			).then(function(device_id){
				device_id = device_id.replace(/"/g,'');
				LocalStorageService.set('device_id', device_id);
				PushNotificationHandler.register();
			});
		}else{
			PushNotificationHandler.register();
		}


	}, false);

	document.addEventListener("networkproblem", function(){
		alertNetworkProblem($scope, $ionicPopup, $state);
	});

	$rootScope.share = function(url){

		window.plugins.socialsharing.share(null, null, null, url);
	};

	$rootScope.magazineHasHowItWorks = function(magazine){
		if(typeof magazine === 'undefined'){
			return false;
		}
		show = false;
		for (key in magazine.performance_in){
			if(magazine.performance_in[key][0].length > 5){
				return true;
			}
		};
		return show;
	};

	AdsService.setAdwordsTracking();
	AdsService.setFacebookConnectTracking();
	AdsService.showInterstitial();
});

var new_version_checked = true;

function alertNewVersion($scope, $ionicPopup, url){
	$scope.showConfirm = function () {
		var confirmPopup = $ionicPopup.show({
			title: 'Actualización disponible',
			template: '¿Deseas actualizar?',
			buttons:[
				{
					text: 'Ahora no',
					type: 'button-default'
				},
				{
					text: 'Si!',
					type: 'button-positive',
					onTap: function (e){
						window.open(url, '_system');
					}
				}
			]
		});
	};
	$scope.showConfirm();
}

var eventNetworkProblem = new Event('networkproblem');
var shown_popup_networkalert = false;

function alertNetworkProblem($scope, $ionicPopup, $state){

	$scope.networkProblem = function () {
		var confirmPopup = $ionicPopup.show({
			title: 'Oops',
			template: 'Parece que estas experimentando problemas de red. ¿Quieres reintentar?',
			buttons:[
				{
					text: 'ok',
					type: 'button-positive',
					onTap: function (e){

						// Workaround para redirigir a la posicion correcta del
						// slider
						params = {};
						if(/\/magazine-list\/:cat_index/.exec($state.current.url)){
							params.cat_index = $scope.cat_index;
						}

						$state.go($state.current, params, {reload: true});
						shown_popup_networkalert = false;
					}
				}
			]
		});
	};
	if(!shown_popup_networkalert){
		$scope.networkProblem();
		shown_popup_networkalert = true;
	}

}
