
controllers.controller(
	
	'MagazineCommentCtrl',
	function(
		$scope,
		$rootScope,
		$stateParams,
		AppServiceManager,
		$ionicNavBarDelegate,
		$ionicPopup,
		$ionicLoading,
		$location,
		$timeout,
		LocalStorageService,
		AnalyticService
		
	){
	
	AnalyticService.trackView('Página de comentario - '+ $stateParams.id);
	
	$rootScope.hideback = true;
	var magazine_id = $stateParams.id;
	
	$scope.goBack = function(){
		$ionicNavBarDelegate.back();
	};
	
	$scope.comment = {};
	$scope.comment.username = ( val = LocalStorageService.get('username') ) ? val : '';
	$scope.comment.email = ( val = LocalStorageService.get('email') ) ? val : '';
	
	$scope.submit = function (){
		
		if($scope.forms.commentForm.$valid){
			
			$ionicLoading.show(_getIonicLoadingParams());
			
			var params = {
				docid : $stateParams.id,
				username : $scope.forms.commentForm.username.$modelValue,
				email : $scope.forms.commentForm.email.$modelValue,
				comment : $scope.forms.commentForm.text.$modelValue,
				uid :getUniqueIdDevice()
				
			};
			
			AppServiceManager.getData(
				'MotofanApiService',
				'saveComment',
				[params],
				false
			).then(function(response){
				
				$ionicLoading.hide();
				if(response.success){
					
					LocalStorageService.set('username', params.username);
					LocalStorageService.set('email', params.email);
					
					var successAlert = $ionicPopup.alert({
							title: 'Gracias por tu comentario!'
					});
					successAlert.then(function(res){
						$timeout(function() {
							$location.path('/app/magazine/' + $stateParams.id);
						});
					});
				}else{
					
					if(!$.isEmptyObject(response.errors)){
						$ionicPopup.alert({
							title: 'Hay errores en el formulario',
							template :  getErrorMessage(response.errors)
						});
					}else{
						$ionicPopup.alert({
							title: 'Algo ha ido mal inténtalo más tarde'
						});
					}
				}
			});
			
		}
		$scope.submitted = true;
	};
});

function getErrorMessage(errors){
	msg = '';
	for(field_name in errors){
		for(key in errors[field_name]){
			msg += errors[field_name][key] + '<br/>';
		}
	}
	return msg;
}