controllers.controller(
'MagazineListCtrl', 
function (
	$scope,
	$rootScope,
	$stateParams,
	AppServiceManager,
	$ionicLoading,
	$ionicSlideBoxDelegate,
	$ionicSideMenuDelegate,
	$ionicScrollDelegate,
	$timeout,
	AnalyticService
) {
	
	$ionicSideMenuDelegate.canDragContent(false);
	
	$scope.lists = _getListParams();
	
	$scope.getMagazineList = function (index, callback, append){
		
		var method = $scope.lists[index].method;
		var page = $scope.lists[index].page;

		AppServiceManager.getData(
			'MotofanApiService',
			method,
			[_getMagazineListParams($scope, index, page)]
		).then(function (data){
			
			_callBackSuccessData(data, index, callback, append);
		});
	};
	
	function _callBackSuccessData(data, index, callback, append){
		
		callback = typeof callback !== 'undefined' ? callback : function(){};
		
		append = typeof callback !== 'undefined' ? append : false;
		
		if(!append) {
			$scope.lists[index].data = data;
		}else{
			$scope.lists[index].data = $scope.lists[index].data.concat(data);
		}
			
		_AreSlidesDefined() ? _moveSelidesToRootScopeIndex() : _refreshSlideBox();
		
		callback(index);
	}

	function _AreSlidesDefined(){
		
		return typeof $ionicSlideBoxDelegate.slidesCount() !== 'undefined';
	}
	
	function _moveSelidesToRootScopeIndex(){
		
		$ionicSlideBoxDelegate.slide($rootScope.cat_index);
		$ionicSlideBoxDelegate.update();
	}
	
	function _refreshSlideBox(){
		
		! _AreSlidesDefined() ? $timeout( _refreshSlideBox, 50) : _moveSelidesToRootScopeIndex();
	}
	
	$scope.onSlideChanged = function (index){
		
		AnalyticService.trackView($scope.lists[index].title);
		$scope.lists[$rootScope.cat_index].page = 1;
		$scope.getMagazineList($rootScope.cat_index);
		$rootScope.cat_index = index;
		$rootScope.roba_cat_index = index;
		
		$scope.getMagazineList($rootScope.cat_index, function() {});
		$ionicScrollDelegate.scrollTop();
		
		if($rootScope.cat_index !== 0){
			$scope.lists[$rootScope.cat_index].more_data = true;
		}
	};
	
	$scope.previousSlide = function (){
		$ionicSlideBoxDelegate.previous();
	};
	$scope.nextSlide = function (){
		$ionicSlideBoxDelegate.next();
	};
	
	$scope.doRefresh = function (){
		
		for( i=1; i<= $scope.lists[$rootScope.cat_index].pages_saved; i++ ){

			AppServiceManager.deleteFromCache(
				'MotofanApiService',
				$scope.lists[$rootScope.cat_index].method,
				[_getMagazineListParams($scope,$rootScope.cat_index, i)]
			);
		}

		$scope.lists[$rootScope.cat_index].pages_saved = 1;
		$scope.lists[$rootScope.cat_index].page = 1;


		$scope.getMagazineList($rootScope.cat_index,function(){
			$scope.$broadcast('scroll.refreshComplete');
		});
	};
	$scope.loadMore = function (){

		var page = ++$scope.lists[$rootScope.cat_index].page;
		$scope.lists[$rootScope.cat_index].pages_saved++;
		$scope.getMagazineList(
				$rootScope.cat_index, 
				function(){
					$scope.$broadcast('scroll.infiniteScrollComplete');
				},page, true);
	};
	
	$scope.moreDataCanBeLoaded = function (){
		return $scope.lists[$rootScope.cat_index].more_data;
	};
	$rootScope.cat_index = Number($stateParams.cat_index);
	$rootScope.roba_cat_index = Number($stateParams.cat_index);
	
	$rootScope.slideToCorretIndex = function(index){
		if($rootScope.cat_index != index){
			$ionicSlideBoxDelegate.slide(index);
		}
	};
	
	$ionicLoading.show(_getIonicLoadingParams());

	$scope.getMagazineList($rootScope.cat_index, function (){
		$ionicLoading.hide();
	});
	if($rootScope.cat_index!=0){
		$scope.lists[$rootScope.cat_index].more_data = true;
	}
	
	AppServiceManager.getData(
			'MotofanApiService',
			'getEditorial',
			[]
		).then(function (data){
			
			if(typeof data !== 'undefined' && data.length){
				$scope.editorials = data;
			}	
		});
	
	AnalyticService.trackView($scope.lists[$rootScope.cat_index].title);
});


function _getListParams(){
	return [
		{
			title: 'Portada', 
			method : 'getHomePlaceholders', 
			id_cat : '',
			pages_saved: 1, 
			page: 1,
			more_data : false,
			data : [{}]
		},
		{
			title: 'Noticias',
			method: 'getMagazines',
			id_cat : 1,
			pages_saved: 1,
			page: 1,
			more_data : false,
			data : [{}]
		},
		{
			title: 'Competición',
			method: 'getMagazines',
			id_cat : 4,
			pages_saved: 1,
			page: 1,
			more_data : false,
			data : [{}]
		},
		{
			title: 'Pruebas',
			method: 'getMagazines',
			id_cat : 9,
			pages_saved: 1,
			page: 1,
			more_data : false,
			data : [{}]
		}
	];
}

function _getMagazineListParams($scope, index, page){
		
	params = {
		limit : 20,
		id_cat : $scope.lists[index].id_cat
	};

	if(typeof page !== 'undefined'){
		params.page = page;
	}

	return params;
}