controllers.controller('SearchCtrl', function (
		$scope,
		$rootScope,
		AppServiceManager,
		$ionicNavBarDelegate,
		$state,
		$ionicLoading
	) {

	$rootScope.hideback = true;
	
	$scope.goBack = function () {
		$ionicNavBarDelegate.back();
	};
	
	var page	= 1;
	var limit	= 20;
	var fetchMoreData	= true;
	
	$scope.search = function () {
		
		if (typeof $scope.search.query !== 'undefined' && $scope.search.query  !== ''){
			
			$ionicLoading.show(_getIonicLoadingParams());
			
			if (window.cordova && window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.close();
			}

			AppServiceManager.getData(
				'MotofanApiService',
				'searchMagazines',
				[{
					q		: $scope.search.query,
					page	: page,
					limit	: limit
				}]
			).then(function (data) {
				
				// Ocultamos o mostramos el empty-state dependiendo de 
				// si obtenemos resultados en la búsqueda
				if(typeof data !== 'undefined' && data.length){
					
					$scope.default		= true;
					$scope.resultList	= false;
					
					$state.get('app.magazine').camefrom.active = true;
					$scope.results		= data;
					loadMoreData($scope, AppServiceManager, page, limit, fetchMoreData);
				} else {
					
					$scope.default	= false;
					$scope.results	= true;
					$scope.query	= $scope.search.query;
					$('.search-message-default').hide();
					$('.search-message-failed').show();
				}
				
				$ionicLoading.hide();
				
			});
		}
	};
});

function loadMoreData ($scope, AppServiceManager, page, limit, fetchMoreData){
	
	$scope.loadMore = function() {

		page++;
		AppServiceManager.getData(
		'MotofanApiService',
		'searchMagazines',
		[{
			q		: $scope.search.query,
			page	: page,
			limit	: limit
		}]
		).then(function (data) {

			if(typeof data !== 'undefined' && data.length){

				$scope.results = $scope.results.concat(data);		
				$scope.$broadcast('scroll.infiniteScrollComplete');
			}else{

				fetchMoreData = false;
			}
		});
	};
	
	$scope.moreDataCanBeLoaded = function (){
		return fetchMoreData;
	};
}