
controllers.directive('scrollWatch', 
	function (
		$rootScope,
		$timeout
	) {
	return function (scope, elem, attr) {
		var start = 0;
		var threshold = 150;
		
		// Hide or show bar of list position
		elem.bind('scroll', function (e) {
			
			action_zone = e.originalEvent.detail.scrollTop - start > threshold;
			same_scrolling_position = $rootScope.slideHeaderPrevious === e.originalEvent.detail.scrollTop - start;
			scrolling_down_action = $rootScope.slideHeaderPrevious < e.originalEvent.detail.scrollTop - start;
			scrolling_up_action = $rootScope.slideHeaderPrevious > e.originalEvent.detail.scrollTop - start;
			
			if (action_zone) {
				if(scrolling_down_action){
					$rootScope.hideSubHeader = true;
				}
				if(scrolling_up_action){
					$rootScope.hideSubHeader = false;
				}
			}else{
				$rootScope.hideSubHeader = false;
			}
			$rootScope.slideHeaderPrevious = e.originalEvent.detail.scrollTop - start;
	
			$timeout(function() { $rootScope.$apply();});
			
		});
		
	};
});