
services.factory('AdsService', function($http){

	var deviceready = false;

	document.addEventListener("deviceready", function(){
		deviceready = true;
	});

	return ({
		getRoba : getRoba,
		showInterstitial : showInterstitial,
		setAdwordsTracking : setAdwordsTracking,
		setFacebookConnectTracking : setFacebookConnectTracking
	});

	/*
	 * Public Methods
	 */
	function getRoba(roba_gap , roba_gap_alias){

		roba_gap.attr('data-status', 'full');

		params = {
			iu	: '/3578157/'+roba_gap_alias,
			sz	: '300x250|300x300',
			c	: getRandomNumberForAds()
		};

		url = 'http://pubads.g.doubleclick.net/gampad/adx?'+$.param(params);

		$http.get(url).success(function (data, status, headers, config){

			var href = /<noscript>[\s\S]*?<a[\s\S]*?href="([^"]+)"/im.exec(data);
			if(href && href.length){

				imgsrc = /<noscript>[\s\S]*?<img[\s\S]*?src="([^"]+)"/im.exec(data);
				if(imgsrc && imgsrc.length){

					roba_gap.find('a').click(function(e){

						e.preventDefault();
						e.stopPropagation();
						window.open(href[1], '_system');
					});
					roba_gap.find('img').attr('src', imgsrc[1]);
					roba_gap.find('img').attr('width', 300);
					roba_gap.find('img').attr('height', 250);
					roba_gap.find('img').attr('style', '');
					return;
				}
			}
			var href = /<a[\s\S]*?href="([^"]+)"/im.exec(data);
			if(href && href.length){

				imgsrc = /<img[\s\S]*?src="([^"]+)"/im.exec(data);
				if(imgsrc && imgsrc.length){
					roba_gap.find('a').click(function(e){

						e.preventDefault();
						e.stopPropagation();
						window.open(href[1], '_system');
					});
					roba_gap.find('img').attr('src', imgsrc[1]);
					roba_gap.find('img').attr('width', 300);
					roba_gap.find('img').attr('height', 250);
					roba_gap.find('img').attr('style', '');
					return;
				}
			}

			roba_gap.hide();

		}).error(function(data, status, headers, config) {
			roba_gap.hide();
		});
	}


	function showInterstitial(){

		isDeviceReady(function(){
			admobid = {
				interstitial: '/3578157/APP_Interstitial'
			};
			// preppare and load ad resource in background, e.g. at begining of game level
			if(typeof AdMob !== 'undefined'){

				 var defaultOptions = {
				// bannerId: admobid.banner,
				// interstitialId: admobid.interstitial,
				// adSize: 'SMART_BANNER',
				// width: integer, // valid when set adSize 'CUSTOM'
				// height: integer, // valid when set adSize 'CUSTOM'
				position: AdMob.AD_POSITION.BOTTOM_CENTER,
				// offsetTopBar: false, // avoid overlapped by status bar, for iOS7+
				bgColor: 'black', // color name, or '#RRGGBB'
				// x: integer, // valid when set position to 0 / POS_XY
				// y: integer, // valid when set position to 0 / POS_XY
				//isTesting: true, // set to true, to receiving test ad for testing purpose
				// autoShow: true // auto show interstitial ad when loaded, set to false if prepare/show
				};
				AdMob.setOptions(defaultOptions);

				AdMob.prepareInterstitial(
					{
						adId:admobid.interstitial,
						autoShow:true
					}, function(msg){//success


					},function(msg){//error
						console.log(msg);
					}
				);
			};
		});
	}

	/**
	 * Códigos de seguimiento de Adwords
	 * El seguimiento de eventos de activación para Facebook se hace de forma automática
	 * cordova -d plugin add /path/to/cloned/phonegap-facebook-plugin --variable APP_ID="123456789" --variable APP_NAME="myApplication"
	 * Source: http://www.mohannadali.com/measurement-for-facebook-mobile-app-ads-on-phonegap/
	 */
	function setAdwordsTracking(){

		isDeviceReady(function(){
			plugins.gapptracker.track("1035433103", "pvglCMfzsFwQj-nd7QM", "1.00", "NO");
		});
	}

	function setFacebookConnectTracking(){

		isDeviceReady(function(){
			facebookConnectPlugin.logEvent('fb_mobile_activate_app');
		});
	}

	/*
	 * Private Methods
	 */
	function getRandomNumberForAds(){
		d = new Date();
		n = String(d.getTime());
		rand = String(Math.floor((Math.random() * 9999) + 1));
		return n + rand;
	}

	function fillRobaGap(){
		roba_gap.find('img').attr('src', imgsrc[1]);
		roba_gap.find('img').attr('width', 300);
		roba_gap.find('img').attr('height', 250);
		roba_gap.find('img').attr('style', '');
	}

	function isDeviceReady(callback){
		setTimeout(function(){
			if(deviceready){
				callback();
			}else{
				isDeviceReady(callback);
			}
		},100);
	}

});
