services.factory('AnalyticService', function(){
	
	var started = false;
	
	return ({
		startTrackerWithId : startTrackerWithId,
		trackView : trackView,
		trackEvent : trackEvent,
		trackException : trackException,
		trackTiming : trackTiming
	});
	/*
	 *  PUBLIC METHODS
	 */
	function startTrackerWithId(id){
		analytics.startTrackerWithId(
				id,
				function(){started=true;},
				handleError
		);
	}
	function trackView(title){
		
		if(isAnalyticPluginLoaded()){
			triggerEventWhenAnalyticEnabled(function(){
				console.log(title);
				analytics.trackView(title,{},handleSuccess, handleError);
			});
			
		}
	};
	function trackEvent(category, action, label, value){
		if(isAnalyticPluginLoaded()){
			triggerEventWhenAnalyticEnabled(function(){
				params = [category, action];
				if (label !== 'undefined'){
					params.push(label);
				}
				if (value !== 'undefined'){
					params.push(value);
				}
				analytics.trackEvent.apply(window.analytics,params);
			});
			
		}
	}
	function trackException(description, fatal){
		if(isAnalyticPluginLoaded()){
			window.analytics.trackException(description, fatal);
		}
	}
	function trackTiming(category, IntervalInMilliseconds, variable, label){
		if(isAnalyticPluginLoaded()){
			analytics.trackTiming(category, IntervalInMilliseconds, variable, label);
		}
	}
	/*
	 *  PRIVATE METHODS
	 */
	function isAnalyticPluginLoaded(){

		return analytics_enabled;
	}
	function triggerEventWhenAnalyticEnabled(callback){
		setTimeout(function(){
			if(started){
				callback();
			}else{
				triggerEventWhenAnalyticEnabled(callback);
			}
		},100);
	}
	function handleSuccess(){
		
	}
	function handleError(err){
		console.log('Analytics error: '+ err);
	}
});