services.factory('MotofanApiService', function($http){
	
	return ({
		getMagazine : getMagazine,
		getMagazineComments : getMagazineComments,
		getMagazines : getMagazines,
		getHomePlaceholders : getHomePlaceholders,
		getEditorial: getEditorial,
		searchMagazines: searchMagazines,
		saveComment	: saveComment,
		saveDevice : saveDevice,
		checkVersion : checkVersion,
		dummy : dummy
	});
	
	// Public Methods
	
	function getMagazine(id){
		
		params ={
			id : id
		};
		
		return $http.get(api_domain +'/magazine?'+$.param(params));
	}
	
	function getMagazineComments(id, page, limit){
		
		params ={
			id : id,
			page : page,
			limit : limit
		};
		
		return $http.get(api_domain +'/comments?'+$.param(params));
	
	}
	
	function getMagazines(params){
		
		return $http.get(api_domain +'/magazineslist?'+$.param(params));

	}
	
	function getHomePlaceholders(params){
		
		return $http.get(api_domain +'/home?'+$.param(params));
	}
	
	function searchMagazines(params){

		return $http.get(api_domain +'/search?'+$.param(params));
	}
	
	function getEditorial(){
		
		return $http.get(api_domain +'/editorial');
	}
	
	function saveComment(params){
		
		return $http.post(api_domain + '/comments', params);
	}
	
	function saveDevice(uid){
		
		params = {
			uid : uid
		};
		
		return $http.post(api_domain + '/device', params);
	}
	
	function checkVersion(version){
		
		params  = {
			platform : device.platform
		};
		
		return $http.get(api_domain +'/checkversion?'+$.param(params));
	}
	
	function dummy(){
		
		params ={
			id : 1
		};

		return $http.get(api_domain +'/dummy?'+$.param(params));
	}
});