services.factory('PushNotificationHandler', function(LocalStorageService){
	
	return {
		register : register,
		onNotificationGCM : onNotificationGCM
	};
	
	/*
	 * Public Methods
	 */
	function register(){
		
		var pushNotification = window.plugins.pushNotification;
		
		// Nuestro dispositivo no está registrado
		if(!LocalStorageService.get('device_id')){
			return false;
		}
		
		if (device.platform === 'Android') {
			
			pushNotification.register(function (result) {
				console.log('Status: ' + result);
			}, function (result) {
				console.log('Error handler ' + result);
			}, {
				senderID: "570793902743", /* Google developers project number */
				ecb: "onNotificationGCM" /* Function name to handle notifications */
			});
		}
	}

});


function onNotificationGCM(e){

	//console.log(JSON.stringify(e));

	switch (e.event) {
		case 'registered':

			if (e.regid.length > 0) {

				var registrationId = e.regid; //GCM Registration ID
				params = {
							id : Number(getFromLocalStorage('device_id')),
							gcm_id : registrationId
						};
				console.log(JSON.stringify(params));
				
				$.put( api_domain + '/device', params, function(data){
					console.log(data);
				});
			}
			break;

		case 'message':
			// handle notification message
			break;

		case 'error':
			// handle error
			break;

		default:
			// handle default
			break;
	}
}

function getFromLocalStorage(key){
	_localStorage = JSON.parse(window.localStorage.getItem('LocalStorageService'));
	return _localStorage[key];
}
